=== ThirdParty/CosmoHaloFinder/CMakeLists.txt ===
vtk_module_third_party_internal(
  LICENSE_FILES 
    "vtkcosmohalofinder/LICENSE"
  SPDX_LICENSE_IDENTIFIER
    "BSD-3-Clause"
  SPDX_COPYRIGHT_TEXT
    "Copyright (c) 2007, Los Alamos National Security, LLC"
  SPDX_DOWNLOAD_LOCATION
    "git+https://gitlab.kitware.com/paraview/paraview/-/tree/master/ThirdParty/CosmoHaloFinder/vtkcosmohalofinder"
  VERSION       
    "master"
  STANDARD_INCLUDE_DIRS)
